package com.bergerkiller.bukkit.nolagg;

import org.bukkit.Chunk;
import org.bukkit.World;
import org.bukkit.craftbukkit.CraftChunk;
import org.bukkit.craftbukkit.CraftWorld;

public class ChunkHandler {	

	public static net.minecraft.server.Chunk getNative(Chunk chunk) {
		return ((CraftChunk) chunk).getHandle();
	}
	public static net.minecraft.server.WorldServer getNative(World world) {
		return ((CraftWorld) world).getHandle();
	}
	public static String toString(Chunk chunk) {
		return "[" + chunk.getX() + "/" + chunk.getZ() + "/" + chunk.getWorld().getName() + "]";
	}
	public static String toString(net.minecraft.server.Chunk chunk) {
		return "[" + chunk.x + "/" + chunk.z + "/" + chunk.world.getWorld().getName() + "]";
	}

	public static boolean transferData(net.minecraft.server.Chunk from, net.minecraft.server.Chunk to) {
		try {
			System.arraycopy(from.b, 0, to.b, 0, from.b.length);
			System.arraycopy(from.g.a, 0, to.g.a, 0, from.g.a.length);
			System.arraycopy(from.h.a, 0, to.h.a, 0, from.h.a.length);
			System.arraycopy(from.i.a, 0, to.i.a, 0, from.i.a.length);
			System.arraycopy(from.heightMap, 0, to.heightMap, 0, from.heightMap.length);
			to.done = from.done;
			return true;
		} catch (Throwable t) {
			t.printStackTrace();
			return false;
		}
	}
	
	public static boolean canSave(net.minecraft.server.Chunk chunk) {
		return chunk.a(false) && chunk.world.getWorld().isAutoSave();
	}
						
}
